diff -uwbBpr libfloat/softfloat/bits64/softfloat.c SoftFloat-2a/softfloat/bits64/softfloat.c
--- libfloat/softfloat/bits64/softfloat.c	Wed Sep 15 16:18:52 1999
+++ SoftFloat-2a/softfloat/bits64/softfloat.c	Mon Sep 20 11:47:08 1999
@@ -1535,7 +1796,7 @@ float32 float32_sub( float32 a, float32 
 -------------------------------------------------------------------------------
 Returns the result of multiplying the single-precision floating-point values
 `a' and `b'.  The operation is performed according to the IEC/IEEE Standard
-for Binary Floating-point Arithmetic.
+for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 float32_mul( float32 a, float32 b )
@@ -1596,7 +1857,7 @@ float32 float32_mul( float32 a, float32 
 -------------------------------------------------------------------------------
 Returns the result of dividing the single-precision floating-point value `a'
 by the corresponding value `b'.  The operation is performed according to the
-IEC/IEEE Standard for Binary Floating-point Arithmetic.
+IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 float32_div( float32 a, float32 b )
@@ -1649,7 +1910,7 @@ float32 float32_div( float32 a, float32 
     }
     zSig = ( ( (bits64) aSig )<<32 ) / bSig;
     if ( ( zSig & 0x3F ) == 0 ) {
-        zSig |= ( ( (bits64) bSig ) * zSig != ( (bits64) aSig )<<32 );
+        zSig |= ( (bits64) bSig * zSig != ( (bits64) aSig )<<32 );
     }
     return roundAndPackFloat32( zSign, zExp, zSig );
 
@@ -1659,7 +1920,7 @@ float32 float32_div( float32 a, float32 
 -------------------------------------------------------------------------------
 Returns the remainder of the single-precision floating-point value `a'
 with respect to the corresponding value `b'.  The operation is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 float32_rem( float32 a, float32 b )
@@ -1760,7 +2021,7 @@ float32 float32_rem( float32 a, float32 
 -------------------------------------------------------------------------------
 Returns the square root of the single-precision floating-point value `a'.
 The operation is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 float32_sqrt( float32 a )
@@ -1793,9 +2054,9 @@ float32 float32_sqrt( float32 a )
     zSig = estimateSqrt32( aExp, aSig ) + 2;
     if ( ( zSig & 0x7F ) <= 5 ) {
         if ( zSig < 2 ) {
-            zSig = 0xFFFFFFFF;
+            zSig = 0x7FFFFFFF;
+            goto roundAndPack;
         }
-        else {
             aSig >>= aExp & 1;
             term = ( (bits64) zSig ) * zSig;
             rem = ( ( (bits64) aSig )<<32 ) - term;
@@ -1805,17 +2066,17 @@ float32 float32_sqrt( float32 a )
             }
             zSig |= ( rem != 0 );
         }
-    }
     shift32RightJamming( zSig, 1, &zSig );
+ roundAndPack:
     return roundAndPackFloat32( 0, zExp, zSig );
 
 }
 
 /*
 -------------------------------------------------------------------------------
-Returns 1 if the single-precision floating-point value `a' is equal to the
-corresponding value `b', and 0 otherwise.  The comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+Returns 1 if the single-precision floating-point value `a' is equal to
+the corresponding value `b', and 0 otherwise.  The comparison is performed
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float32_eq( float32 a, float32 b )
@@ -1835,9 +2096,9 @@ flag float32_eq( float32 a, float32 b )
 
 /*
 -------------------------------------------------------------------------------
-Returns 1 if the single-precision floating-point value `a' is less than or
-equal to the corresponding value `b', and 0 otherwise.  The comparison is
-performed according to the IEC/IEEE Standard for Binary Floating-point
+Returns 1 if the single-precision floating-point value `a' is less than
+or equal to the corresponding value `b', and 0 otherwise.  The comparison
+is performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -1862,7 +2123,7 @@ flag float32_le( float32 a, float32 b )
 -------------------------------------------------------------------------------
 Returns 1 if the single-precision floating-point value `a' is less than
 the corresponding value `b', and 0 otherwise.  The comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float32_lt( float32 a, float32 b )
@@ -1884,10 +2145,10 @@ flag float32_lt( float32 a, float32 b )
 
 /*
 -------------------------------------------------------------------------------
-Returns 1 if the single-precision floating-point value `a' is equal to the
-corresponding value `b', and 0 otherwise.  The invalid exception is raised
-if either operand is a NaN.  Otherwise, the comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+Returns 1 if the single-precision floating-point value `a' is equal to
+the corresponding value `b', and 0 otherwise.  The invalid exception is
+raised if either operand is a NaN.  Otherwise, the comparison is performed
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float32_eq_signaling( float32 a, float32 b )
@@ -1908,7 +2169,7 @@ flag float32_eq_signaling( float32 a, fl
 Returns 1 if the single-precision floating-point value `a' is less than or
 equal to the corresponding value `b', and 0 otherwise.  Quiet NaNs do not
 cause an exception.  Otherwise, the comparison is performed according to the
-IEC/IEEE Standard for Binary Floating-point Arithmetic.
+IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float32_le_quiet( float32 a, float32 b )
@@ -1936,7 +2197,7 @@ flag float32_le_quiet( float32 a, float3
 Returns 1 if the single-precision floating-point value `a' is less than
 the corresponding value `b', and 0 otherwise.  Quiet NaNs do not cause an
 exception.  Otherwise, the comparison is performed according to the IEC/IEEE
-Standard for Binary Floating-point Arithmetic.
+Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float32_lt_quiet( float32 a, float32 b )
@@ -1962,7 +2223,7 @@ flag float32_lt_quiet( float32 a, float3
 -------------------------------------------------------------------------------
 Returns the result of converting the double-precision floating-point value
 `a' to the 32-bit two's complement integer format.  The conversion is
-performed according to the IEC/IEEE Standard for Binary Floating-point
+performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic---which means in particular that the conversion is rounded
 according to the current rounding mode.  If `a' is a NaN, the largest
 positive integer is returned.  Otherwise, if the conversion overflows, the
@@ -1990,10 +2251,10 @@ int32 float64_to_int32( float64 a )
 -------------------------------------------------------------------------------
 Returns the result of converting the double-precision floating-point value
 `a' to the 32-bit two's complement integer format.  The conversion is
-performed according to the IEC/IEEE Standard for Binary Floating-point
-Arithmetic, except that the conversion is always rounded toward zero.  If
-`a' is a NaN, the largest positive integer is returned.  Otherwise, if the
-conversion overflows, the largest integer with the same sign as `a' is
+performed according to the IEC/IEEE Standard for Binary Floating-Point
+Arithmetic, except that the conversion is always rounded toward zero.
+If `a' is a NaN, the largest positive integer is returned.  Otherwise, if
+the conversion overflows, the largest integer with the same sign as `a' is
 returned.
 -------------------------------------------------------------------------------
 */
@@ -2007,24 +2268,24 @@ int32 float64_to_int32_round_to_zero( fl
     aSig = extractFloat64Frac( a );
     aExp = extractFloat64Exp( a );
     aSign = extractFloat64Sign( a );
-    shiftCount = 0x433 - aExp;
-    if ( shiftCount < 21 ) {
+    if ( 0x41E < aExp ) {
         if ( ( aExp == 0x7FF ) && aSig ) aSign = 0;
         goto invalid;
     }
-    else if ( 52 < shiftCount ) {
+    else if ( aExp < 0x3FF ) {
         if ( aExp || aSig ) float_exception_flags |= float_flag_inexact;
         return 0;
     }
     aSig |= LIT64( 0x0010000000000000 );
+    shiftCount = 0x433 - aExp;
     savedASig = aSig;
     aSig >>= shiftCount;
     z = aSig;
     if ( aSign ) z = - z;
     if ( ( z < 0 ) ^ aSign ) {
  invalid:
-        float_exception_flags |= float_flag_invalid;
-        return aSign ? 0x80000000 : 0x7FFFFFFF;
+        float_raise( float_flag_invalid );
+        return aSign ? (sbits32) 0x80000000 : 0x7FFFFFFF;
     }
     if ( ( aSig<<shiftCount ) != savedASig ) {
         float_exception_flags |= float_flag_inexact;
@@ -2036,73 +2297,97 @@ int32 float64_to_int32_round_to_zero( fl
 /*
 -------------------------------------------------------------------------------
 Returns the result of converting the double-precision floating-point value
-`a' to the 32-bit two's complement unsigned integer format.  The conversion
-is performed according to the IEC/IEEE Standard for Binary Floating-point
+`a' to the 64-bit two's complement integer format.  The conversion is
+performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic---which means in particular that the conversion is rounded
 according to the current rounding mode.  If `a' is a NaN, the largest
 positive integer is returned.  Otherwise, if the conversion overflows, the
-largest positive integer is returned.
+largest integer with the same sign as `a' is returned.
 -------------------------------------------------------------------------------
 */
-int32 float64_to_uint32( float64 a )
+int64 float64_to_int64( float64 a )
 {
     flag aSign;
     int16 aExp, shiftCount;
-    bits64 aSig;
+    bits64 aSig, aSigExtra;
 
     aSig = extractFloat64Frac( a );
     aExp = extractFloat64Exp( a );
-    aSign = 0; //extractFloat64Sign( a );
-    //if ( ( aExp == 0x7FF ) && aSig ) aSign = 0;
+    aSign = extractFloat64Sign( a );
     if ( aExp ) aSig |= LIT64( 0x0010000000000000 );
-    shiftCount = 0x42C - aExp;
-    if ( 0 < shiftCount ) shift64RightJamming( aSig, shiftCount, &aSig );
-    return roundAndPackInt32( aSign, aSig );
+    shiftCount = 0x433 - aExp;
+    if ( shiftCount <= 0 ) {
+        if ( 0x43E < aExp ) {
+            float_raise( float_flag_invalid );
+            if (    ! aSign
+                 || (    ( aExp == 0x7FF )
+                      && ( aSig != LIT64( 0x0010000000000000 ) ) )
+               ) {
+                return LIT64( 0x7FFFFFFFFFFFFFFF );
+            }
+            return (sbits64) LIT64( 0x8000000000000000 );
+        }
+        aSigExtra = 0;
+        aSig <<= - shiftCount;
+    }
+    else {
+        shift64ExtraRightJamming( aSig, 0, shiftCount, &aSig, &aSigExtra );
+    }
+    return roundAndPackInt64( aSign, aSig, aSigExtra );
+
 }
 
 /*
 -------------------------------------------------------------------------------
 Returns the result of converting the double-precision floating-point value
-`a' to the 32-bit two's complement integer format.  The conversion is
-performed according to the IEC/IEEE Standard for Binary Floating-point
-Arithmetic, except that the conversion is always rounded toward zero.  If
-`a' is a NaN, the largest positive integer is returned.  Otherwise, if the
-conversion overflows, the largest positive integer is returned.
+`a' to the 64-bit two's complement integer format.  The conversion is
+performed according to the IEC/IEEE Standard for Binary Floating-Point
+Arithmetic, except that the conversion is always rounded toward zero.
+If `a' is a NaN, the largest positive integer is returned.  Otherwise, if
+the conversion overflows, the largest integer with the same sign as `a' is
+returned.
 -------------------------------------------------------------------------------
 */
-int32 float64_to_uint32_round_to_zero( float64 a )
+int64 float64_to_int64_round_to_zero( float64 a )
 {
     flag aSign;
     int16 aExp, shiftCount;
-    bits64 aSig, savedASig;
-    int32 z;
+    bits64 aSig;
+    int64 z;
 
     aSig = extractFloat64Frac( a );
     aExp = extractFloat64Exp( a );
     aSign = extractFloat64Sign( a );
-    shiftCount = 0x433 - aExp;
-    if ( shiftCount < 21 ) {
-        if ( ( aExp == 0x7FF ) && aSig ) aSign = 0;
-        goto invalid;
+    if ( aExp ) aSig |= LIT64( 0x0010000000000000 );
+    shiftCount = aExp - 0x433;
+    if ( 0 <= shiftCount ) {
+        if ( 0x43E <= aExp ) {
+            if ( a != LIT64( 0xC3E0000000000000 ) ) {
+                float_raise( float_flag_invalid );
+                if (    ! aSign
+                     || (    ( aExp == 0x7FF )
+                          && ( aSig != LIT64( 0x0010000000000000 ) ) )
+                   ) {
+                    return LIT64( 0x7FFFFFFFFFFFFFFF );
     }
-    else if ( 52 < shiftCount ) {
-        if ( aExp || aSig ) float_exception_flags |= float_flag_inexact;
-        return 0;
     }
-    aSig |= LIT64( 0x0010000000000000 );
-    savedASig = aSig;
-    aSig >>= shiftCount;
-    z = aSig;
-    if ( aSign ) z = - z;
-    if ( ( z < 0 ) ^ aSign ) {
- invalid:
-        float_exception_flags |= float_flag_invalid;
-        return aSign ? 0x80000000 : 0x7FFFFFFF;
+            return (sbits64) LIT64( 0x8000000000000000 );
     }
-    if ( ( aSig<<shiftCount ) != savedASig ) {
+        z = aSig<<shiftCount;
+    }
+    else {
+        if ( aExp < 0x3FE ) {
+            if ( aExp | aSig ) float_exception_flags |= float_flag_inexact;
+            return 0;
+        }
+        z = aSig>>( - shiftCount );
+        if ( (bits64) ( aSig<<( shiftCount & 63 ) ) ) {
         float_exception_flags |= float_flag_inexact;
     }
+    }
+    if ( aSign ) z = - z;
     return z;
+
 }
 
 /*
@@ -2109,7 +2394,7 @@ int32 float64_to_uint32_round_to_zero( f
 -------------------------------------------------------------------------------
 Returns the result of converting the double-precision floating-point value
 `a' to the single-precision floating-point format.  The conversion is
-performed according to the IEC/IEEE Standard for Binary Floating-point
+performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -2143,7 +2428,7 @@ float32 float64_to_float32( float64 a )
 -------------------------------------------------------------------------------
 Returns the result of converting the double-precision floating-point value
 `a' to the extended double-precision floating-point format.  The conversion
-is performed according to the IEC/IEEE Standard for Binary Floating-point
+is performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -2178,7 +2463,7 @@ floatx80 float64_to_floatx80( float64 a 
 -------------------------------------------------------------------------------
 Returns the result of converting the double-precision floating-point value
 `a' to the quadruple-precision floating-point format.  The conversion is
-performed according to the IEC/IEEE Standard for Binary Floating-point
+performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -2212,7 +2497,7 @@ float128 float64_to_float128( float64 a 
 Rounds the double-precision floating-point value `a' to an integer, and
 returns the result as a double-precision floating-point value.  The
 operation is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 float64_round_to_int( float64 a )
@@ -2230,7 +2515,7 @@ float64 float64_round_to_int( float64 a 
         }
         return a;
     }
-    if ( aExp <= 0x3FE ) {
+    if ( aExp < 0x3FF ) {
         if ( (bits64) ( a<<1 ) == 0 ) return a;
         float_exception_flags |= float_flag_inexact;
         aSign = extractFloat64Sign( a );
@@ -2271,10 +2556,10 @@ float64 float64_round_to_int( float64 a 
 /*
 -------------------------------------------------------------------------------
 Returns the result of adding the absolute values of the double-precision
-floating-point values `a' and `b'.  If `zSign' is true, the sum is negated
-before being returned.  `zSign' is ignored if the result is a NaN.  The
-addition is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+floating-point values `a' and `b'.  If `zSign' is 1, the sum is negated
+before being returned.  `zSign' is ignored if the result is a NaN.
+The addition is performed according to the IEC/IEEE Standard for Binary
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static float64 addFloat64Sigs( float64 a, float64 b, flag zSign )
@@ -2343,10 +2628,10 @@ static float64 addFloat64Sigs( float64 a
 /*
 -------------------------------------------------------------------------------
 Returns the result of subtracting the absolute values of the double-
-precision floating-point values `a' and `b'.  If `zSign' is true, the
+precision floating-point values `a' and `b'.  If `zSign' is 1, the
 difference is negated before being returned.  `zSign' is ignored if the
 result is a NaN.  The subtraction is performed according to the IEC/IEEE
-Standard for Binary Floating-point Arithmetic.
+Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static float64 subFloat64Sigs( float64 a, float64 b, flag zSign )
@@ -2420,7 +2705,7 @@ static float64 subFloat64Sigs( float64 a
 -------------------------------------------------------------------------------
 Returns the result of adding the double-precision floating-point values `a'
 and `b'.  The operation is performed according to the IEC/IEEE Standard for
-Binary Floating-point Arithmetic.
+Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 float64_add( float64 a, float64 b )
@@ -2442,7 +2727,7 @@ float64 float64_add( float64 a, float64 
 -------------------------------------------------------------------------------
 Returns the result of subtracting the double-precision floating-point values
 `a' and `b'.  The operation is performed according to the IEC/IEEE Standard
-for Binary Floating-point Arithmetic.
+for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 float64_sub( float64 a, float64 b )
@@ -2464,7 +2749,7 @@ float64 float64_sub( float64 a, float64 
 -------------------------------------------------------------------------------
 Returns the result of multiplying the double-precision floating-point values
 `a' and `b'.  The operation is performed according to the IEC/IEEE Standard
-for Binary Floating-point Arithmetic.
+for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 float64_mul( float64 a, float64 b )
@@ -2523,7 +2808,7 @@ float64 float64_mul( float64 a, float64 
 -------------------------------------------------------------------------------
 Returns the result of dividing the double-precision floating-point value `a'
 by the corresponding value `b'.  The operation is performed according to
-the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 float64_div( float64 a, float64 b )
@@ -2594,7 +2879,7 @@ float64 float64_div( float64 a, float64 
 -------------------------------------------------------------------------------
 Returns the remainder of the double-precision floating-point value `a'
 with respect to the corresponding value `b'.  The operation is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 float64_rem( float64 a, float64 b )
@@ -2680,15 +2965,15 @@ float64 float64_rem( float64 a, float64 
 -------------------------------------------------------------------------------
 Returns the square root of the double-precision floating-point value `a'.
 The operation is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 float64_sqrt( float64 a )
 {
     flag aSign;
     int16 aExp, zExp;
-    bits64 aSig, zSig;
-    bits64 rem0, rem1, term0, term1, shiftedRem;
+    bits64 aSig, zSig, doubleZSig;
+    bits64 rem0, rem1, term0, term1;
     float64 z;
 
     aSig = extractFloat64Frac( a );
@@ -2712,27 +2997,19 @@ float64 float64_sqrt( float64 a )
     zExp = ( ( aExp - 0x3FF )>>1 ) + 0x3FE;
     aSig |= LIT64( 0x0010000000000000 );
     zSig = estimateSqrt32( aExp, aSig>>21 );
-    zSig <<= 31;
     aSig <<= 9 - ( aExp & 1 );
-    zSig = estimateDiv128To64( aSig, 0, zSig ) + zSig + 2;
-    if ( ( zSig & 0x3FF ) <= 5 ) {
-        if ( zSig < 2 ) {
-            zSig = LIT64( 0xFFFFFFFFFFFFFFFF );
-        }
-        else {
-            aSig <<= 2;
+    zSig = estimateDiv128To64( aSig, 0, zSig<<32 ) + ( zSig<<30 );
+    if ( ( zSig & 0x1FF ) <= 5 ) {
+        doubleZSig = zSig<<1;
             mul64To128( zSig, zSig, &term0, &term1 );
             sub128( aSig, 0, term0, term1, &rem0, &rem1 );
             while ( (sbits64) rem0 < 0 ) {
                 --zSig;
-                shortShift128Left( 0, zSig, 1, &term0, &term1 );
-                term1 |= 1;
-                add128( rem0, rem1, term0, term1, &rem0, &rem1 );
+            doubleZSig -= 2;
+            add128( rem0, rem1, zSig>>63, doubleZSig | 1, &rem0, &rem1 );
             }
             zSig |= ( ( rem0 | rem1 ) != 0 );
         }
-    }
-    shift64RightJamming( zSig, 1, &zSig );
     return roundAndPackFloat64( 0, zExp, zSig );
 
 }
@@ -2741,7 +3018,7 @@ float64 float64_sqrt( float64 a )
 -------------------------------------------------------------------------------
 Returns 1 if the double-precision floating-point value `a' is equal to the
 corresponding value `b', and 0 otherwise.  The comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float64_eq( float64 a, float64 b )
@@ -2763,7 +3040,7 @@ flag float64_eq( float64 a, float64 b )
 -------------------------------------------------------------------------------
 Returns 1 if the double-precision floating-point value `a' is less than or
 equal to the corresponding value `b', and 0 otherwise.  The comparison is
-performed according to the IEC/IEEE Standard for Binary Floating-point
+performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -2788,7 +3065,7 @@ flag float64_le( float64 a, float64 b )
 -------------------------------------------------------------------------------
 Returns 1 if the double-precision floating-point value `a' is less than
 the corresponding value `b', and 0 otherwise.  The comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float64_lt( float64 a, float64 b )
@@ -2813,7 +3090,7 @@ flag float64_lt( float64 a, float64 b )
 Returns 1 if the double-precision floating-point value `a' is equal to the
 corresponding value `b', and 0 otherwise.  The invalid exception is raised
 if either operand is a NaN.  Otherwise, the comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float64_eq_signaling( float64 a, float64 b )
@@ -2834,7 +3111,7 @@ flag float64_eq_signaling( float64 a, fl
 Returns 1 if the double-precision floating-point value `a' is less than or
 equal to the corresponding value `b', and 0 otherwise.  Quiet NaNs do not
 cause an exception.  Otherwise, the comparison is performed according to the
-IEC/IEEE Standard for Binary Floating-point Arithmetic.
+IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float64_le_quiet( float64 a, float64 b )
@@ -2862,7 +3139,7 @@ flag float64_le_quiet( float64 a, float6
 Returns 1 if the double-precision floating-point value `a' is less than
 the corresponding value `b', and 0 otherwise.  Quiet NaNs do not cause an
 exception.  Otherwise, the comparison is performed according to the IEC/IEEE
-Standard for Binary Floating-point Arithmetic.
+Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float64_lt_quiet( float64 a, float64 b )
@@ -2891,7 +3168,7 @@ flag float64_lt_quiet( float64 a, float6
 Returns the result of converting the extended double-precision floating-
 point value `a' to the 32-bit two's complement integer format.  The
 conversion is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic---which means in particular that the conversion
+Floating-Point Arithmetic---which means in particular that the conversion
 is rounded according to the current rounding mode.  If `a' is a NaN, the
 largest positive integer is returned.  Otherwise, if the conversion
 overflows, the largest integer with the same sign as `a' is returned.
@@ -2919,7 +3196,7 @@ int32 floatx80_to_int32( floatx80 a )
 Returns the result of converting the extended double-precision floating-
 point value `a' to the 32-bit two's complement integer format.  The
 conversion is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic, except that the conversion is always rounded
+Floating-Point Arithmetic, except that the conversion is always rounded
 toward zero.  If `a' is a NaN, the largest positive integer is returned.
 Otherwise, if the conversion overflows, the largest integer with the same
 sign as `a' is returned.
@@ -2935,23 +3212,23 @@ int32 floatx80_to_int32_round_to_zero( f
     aSig = extractFloatx80Frac( a );
     aExp = extractFloatx80Exp( a );
     aSign = extractFloatx80Sign( a );
-    shiftCount = 0x403E - aExp;
-    if ( shiftCount < 32 ) {
+    if ( 0x401E < aExp ) {
         if ( ( aExp == 0x7FFF ) && (bits64) ( aSig<<1 ) ) aSign = 0;
         goto invalid;
     }
-    else if ( 63 < shiftCount ) {
+    else if ( aExp < 0x3FFF ) {
         if ( aExp || aSig ) float_exception_flags |= float_flag_inexact;
         return 0;
     }
+    shiftCount = 0x403E - aExp;
     savedASig = aSig;
     aSig >>= shiftCount;
     z = aSig;
     if ( aSign ) z = - z;
     if ( ( z < 0 ) ^ aSign ) {
  invalid:
-        float_exception_flags |= float_flag_invalid;
-        return aSign ? 0x80000000 : 0x7FFFFFFF;
+        float_raise( float_flag_invalid );
+        return aSign ? (sbits32) 0x80000000 : 0x7FFFFFFF;
     }
     if ( ( aSig<<shiftCount ) != savedASig ) {
         float_exception_flags |= float_flag_inexact;
